Index: trunk/kernel/kern/cluster.c
===================================================================
--- trunk/kernel/kern/cluster.c	(revision 690)
+++ trunk/kernel/kern/cluster.c	(revision 1)
@@ -682,104 +397,214 @@
 
     // get extended pointer on lock protecting copies_list[lpid]
-    xptr_t copies_lock  = XPTR( owner_cxy , &pm->copies_lock[lpid] );
+    xptr_t copies_lock  = hal_remote_lwd( XPTR( owner_cxy , &pm->copies_lock[lpid] ) );
 
     // get extended pointer on the local copies_list entry
     xptr_t copies_entry = XPTR( local_cxy , &process->copies_list );
 
-    // get lock protecting copies_list[lpid]
-    remote_queuelock_acquire( copies_lock );
-
-    // remove copy from copies_list
+    // get lock protecting copies_list[lpid] 
+    remote_spinlock_lock( copies_lock );
+
     xlist_unlink( copies_entry );
     hal_remote_atomic_add( XPTR( owner_cxy , &pm->copies_nr[lpid] ) , -1 );
 
-    // release lock protecting copies_list[lpid]
-    remote_queuelock_release( copies_lock );
-
-#if DEBUG_CLUSTER_PROCESS_COPIES
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_CLUSTER_PROCESS_COPIES < cycle )
-printk("\n[%s] thread[%x,%x] exit for process %x / cycle %d\n",
-__FUNCTION__ , this->process->pid , this->trdid , process->pid , cycle );
+    // release lock protecting copies_list[lpid] 
+    remote_spinlock_unlock( copies_lock );
+}
+
+////////////////////////////////////////////////////////////////////////////////////////
+// TODO Il me semble que la seule chose que fait ce kernel thread à chaque réveil
+// est de mettre à jour la DQDT, et de se rendormir... A-t-on besoin d'un thread ? [AG] 
+//////////////////////////////////////////////////////////////////////////////////////////
+
+#if 0
+void * cluster_manager_thread( void * arg )
+{
+	register struct dqdt_cluster_s * root;
+	register struct cluster_s      * root_home;
+
+	register uint32_t                tm_start;
+	register uint32_t                tm_end;
+	register uint32_t                cpu_id;
+	struct cluster_s               * cluster;
+	struct thread_s                * this;
+	struct event_s                   event;
+	struct alarm_info_s              info;
+	register uint32_t                cntr;
+	register bool_t                  isRootMgr;
+	register uint32_t                period;
+
+	cpu_enable_all_irq( NULL );
+
+	cluster   = arg;
+	this      = CURRENT_THREAD;
+	cpu_id    = cpu_get_id();
+	root      = dqdt_root;
+	root_home = dqdt_root->home;
+	isRootMgr = (cluster == root_home) ? true : false;
+	cntr      = 0;
+	period    = (isRootMgr) ? 
+		CONFIG_DQDT_ROOTMGR_PERIOD * MSEC_PER_TICK : 
+		CONFIG_DQDT_MGR_PERIOD * MSEC_PER_TICK;
+
+	event_set_senderId(&event, this);
+	event_set_priority(&event, E_CHR);
+	event_set_handler(&event, &manager_alarm_event_handler);
+  
+	info.event = &event;
+	thread_preempt_disable(CURRENT_THREAD);
+
+    // infinite loop
+	while(1)
+	{
+		tm_start = cpu_time_stamp();
+		dqdt_update();
+		tm_end   = cpu_time_stamp();
+
+		if(isRootMgr)
+		{
+			if((cntr % 10) == 0)
+			{
+				printk(INFO, "INFO: cpu %d, DQDT update ended [ %u - %u ]\n", 
+				       cpu_id, 
+				       tm_end, 
+				       tm_end - tm_start);
+
+				dqdt_print_summary(root);
+			}
+		}
+
+		alarm_wait( &info , period );
+		sched_sleep(this);
+		cntr ++;
+	}
+
+	return NULL;
+} // end cluster_manager_thread()
+
+//////////////////////////////////////////
+EVENT_HANDLER(manager_alarm_event_handler)
+{
+	struct thread_s *manager;
+ 
+	manager = event_get_senderId(event);
+ 
+	thread_preempt_disable(CURRENT_THREAD);
+
+	//printk(INFO, "%s: cpu %d [%u]\n", __FUNCTION__, cpu_get_id(), cpu_time_stamp());
+
+	sched_wakeup(manager);
+  
+	thread_preempt_enable(CURRENT_THREAD);
+
+	return 0;
+}
+
+///////////////////////////////////////////////
+EVENT_HANDLER(cluster_key_create_event_handler)
+{
+	struct cluster_s *cluster;
+	struct thread_s *sender;
+	ckey_t *ckey;
+	uint32_t key;
+
+	sender  = event_get_senderId(event);
+	ckey    = event_get_argument(event);
+	cluster = current_cluster;
+	key     = cluster->next_key;
+
+	while((key < CLUSTER_TOTAL_KEYS_NR) && (cluster->keys_tbl[key] != NULL))
+		key ++;
+
+	if(key < CLUSTER_TOTAL_KEYS_NR)
+	{
+		ckey->val = key;
+		cluster->keys_tbl[key] = (void *) 0x1; // Reserved 
+		cluster->next_key = key;
+		event_set_error(event, 0);
+	}
+	else
+		event_set_error(event, ENOSPC);
+
+	sched_wakeup(sender);
+	return 0;
+}
+
+///////////////////////////////////////////////
+EVENT_HANDLER(cluster_key_delete_event_handler)
+{
+	struct cluster_s *cluster;
+	struct thread_s *sender;
+	ckey_t *ckey;
+	uint32_t key;
+
+	sender  = event_get_senderId(event);
+	ckey    = event_get_argument(event);
+	cluster = current_cluster;
+	key     = ckey->val;
+
+	if(key < cluster->next_key)
+		cluster->next_key = key;
+
+	cluster->keys_tbl[key] = NULL;
+	event_set_error(event, 0);
+
+	sched_wakeup(sender);
+	return 0;
+}
+
+#define _CKEY_CREATE  0x0
+#define _CKEY_DELETE  0x1
+
+error_t cluster_do_key_op(ckey_t *key, uint32_t op)
+{
+	struct event_s event;
+	struct thread_s *this;
+	struct cluster_s *cluster;
+	struct cpu_s *cpu;
+
+	this = CURRENT_THREAD;
+
+	event_set_priority(&event, E_FUNC);
+	event_set_senderId(&event, this);
+	event_set_argument(&event, key);
+
+	if(op == _CKEY_CREATE)
+		event_set_handler(&event, cluster_key_create_event_handler);
+	else
+		event_set_handler(&event, cluster_key_delete_event_handler);
+
+	cluster = current_cluster;
+	cpu     = cluster->bscluster->bscpu;
+	event_send(&event, &cpu->re_listner);
+
+	sched_sleep(this);
+
+	return event_get_error(&event);
+}
+
+error_t cluster_key_create(ckey_t *key)
+{
+	return cluster_do_key_op(key, _CKEY_CREATE);
+}
+
+error_t cluster_key_delete(ckey_t *key)
+{
+	return cluster_do_key_op(key, _CKEY_DELETE);
+}
+
+void* cluster_getspecific(ckey_t *key)
+{
+	struct cluster_s *cluster;
+
+	cluster = current_cluster;
+	return cluster->keys_tbl[key->val];
+}
+
+void  cluster_setspecific(ckey_t *key, void *val)
+{
+	struct cluster_s *cluster;
+
+	cluster = current_cluster;
+	cluster->keys_tbl[key->val] = val;
+}
 #endif
-
-}  // end cluster_process_copies_unlink()
-
-////////////////////////////////////////////
-void cluster_processes_display( cxy_t   cxy,
-                                bool_t  owned )
-{
-    xptr_t        root_xp;
-    xptr_t        lock_xp;
-    xptr_t        iter_xp;
-    xptr_t        process_xp;
-    process_t   * process_ptr;
-    cxy_t         process_cxy;
-    pid_t         pid;
-    cxy_t         txt0_cxy;
-    chdev_t     * txt0_ptr;
-    xptr_t        txt0_xp;
-    xptr_t        txt0_lock_xp;
-    uint32_t      pref_nr;       // number of owned processes in cluster cxy
-
-assert( __FUNCTION__, (cluster_is_active( cxy ) ), "illegal cluster index" );
-
-    // get extended pointer on root and lock for local process list in cluster
-    root_xp = XPTR( cxy , &LOCAL_CLUSTER->pmgr.local_root );
-    lock_xp = XPTR( cxy , &LOCAL_CLUSTER->pmgr.local_lock );
-
-    // get number of owned processes in cluster cxy
-    pref_nr = hal_remote_l32( XPTR( cxy , &LOCAL_CLUSTER->pmgr.pref_nr ) );
-
-    // display nothing if no user process in cluster cxy
-    if( (owned != false) && (pref_nr < 2) ) return;
-    
-    // get pointers on TXT0 chdev
-    txt0_xp  = chdev_dir.txt_tx[0];
-    txt0_cxy = GET_CXY( txt0_xp );
-    txt0_ptr = GET_PTR( txt0_xp );
-
-    // get extended pointer on TXT0 lock
-    txt0_lock_xp = XPTR( txt0_cxy , &txt0_ptr->wait_lock );
-
-    // get lock on local process list 
-    remote_queuelock_acquire( lock_xp );
-
-    // get TXT0 lock
-    remote_busylock_acquire( txt0_lock_xp );
-     
-    nolock_printk("\n***** processes in cluster %x / cycle %d\n",
-    cxy , (uint32_t)hal_get_cycles() );
-
-    // loop on all processes in cluster cxy 
-    XLIST_FOREACH( root_xp , iter_xp )
-    {
-        process_xp  = XLIST_ELEMENT( iter_xp , process_t , local_list );
-        process_ptr = GET_PTR( process_xp );
-        process_cxy = GET_CXY( process_xp );
-
-        // get process PID
-        pid = hal_remote_l32( XPTR( process_cxy , &process_ptr->pid ) );
-
-        if( owned )  // display only user & owned processes 
-        {
-            if( (CXY_FROM_PID( pid ) == cxy) && (LPID_FROM_PID( pid ) != 0) )
-            {
-                process_display( process_xp );
-            }
-        }
-        else         // display all local processes
-        {
-            process_display( process_xp );
-        }
-    }
-
-    // release TXT0 lock 
-    remote_busylock_release( txt0_lock_xp );
-
-    // release lock on local process list
-    remote_queuelock_release( lock_xp );
-
-}  // end cluster_processes_display() 
-
-
